diff --git a/argp/argp-help.c b/argp/argp-help.c
index 0ccd012084..52ec2316fa 100644
--- a/argp/argp-help.c
+++ b/argp/argp-help.c
@@ -1540,7 +1540,7 @@ argp_doc (const struct argp *argp, const struct argp_state *state,
 }
 
 /* Output a usage message for ARGP to STREAM.  If called from
-   argp_state_help, STATE is the relevent parsing state.  FLAGS are from the
+   argp_state_help, STATE is the relevant parsing state.  FLAGS are from the
    set ARGP_HELP_*.  NAME is what to use wherever a `program name' is
    needed. */
 static void
diff --git a/misc/sys/cdefs.h b/misc/sys/cdefs.h
index d1f5fe208d..88bc7ac942 100644
--- a/misc/sys/cdefs.h
+++ b/misc/sys/cdefs.h
@@ -337,7 +337,7 @@
    semantics.
 
    clang++ identifies itself as gcc-4.2, but has support for GNU inlining
-   semantics, that can be checked fot by using the __GNUC_STDC_INLINE_ and
+   semantics, that can be checked for by using the __GNUC_STDC_INLINE_ and
    __GNUC_GNU_INLINE__ macro definitions.  */
 #if (!defined __cplusplus || __GNUC_PREREQ (4,3) \
      || (defined __clang__ && (defined __GNUC_STDC_INLINE__ \
diff --git a/posix/regexec.c b/posix/regexec.c
index 0a7a27b772..91d5a797b8 100644
--- a/posix/regexec.c
+++ b/posix/regexec.c
@@ -2207,7 +2207,7 @@ sift_states_iter_mb (const re_match_context_t *mctx, re_sift_context_t *sctx,
 			    dfa->nexts[node_idx]))
     /* The node can't accept the "multi byte", or the
        destination was already thrown away, then the node
-       could't accept the current input "multi byte".   */
+       couldn't accept the current input "multi byte".   */
     naccepted = 0;
   /* Otherwise, it is sure that the node could accept
      'naccepted' bytes input.  */
diff --git a/socket/sockatmark.c b/socket/sockatmark.c
index 3ffb014a8d..d6a13c84d5 100644
--- a/socket/sockatmark.c
+++ b/socket/sockatmark.c
@@ -18,7 +18,7 @@
 #include <errno.h>
 #include <sys/socket.h>
 
-/* Determine wheter socket is at a out-of-band mark.  */
+/* Determine whether socket is at a out-of-band mark.  */
 int
 sockatmark (int fd)
 {
diff --git a/socket/sys/socket.h b/socket/sys/socket.h
index 37e4a4af06..6f242d088b 100644
--- a/socket/sys/socket.h
+++ b/socket/sys/socket.h
@@ -251,7 +251,7 @@ extern int shutdown (int __fd, int __how) __THROW;
 
 
 #ifdef __USE_XOPEN2K
-/* Determine wheter socket is at a out-of-band mark.  */
+/* Determine whether socket is at a out-of-band mark.  */
 extern int sockatmark (int __fd) __THROW;
 #endif
 
diff --git a/sysdeps/ia64/fpu/libm_sincos_large.S b/sysdeps/ia64/fpu/libm_sincos_large.S
index 9faa75980f..64c42662dd 100644
--- a/sysdeps/ia64/fpu/libm_sincos_large.S
+++ b/sysdeps/ia64/fpu/libm_sincos_large.S
@@ -223,7 +223,7 @@
 //           = (-1)^i_0 * [cos(r) - c*r] if i_1 = 1
 //
 //  because |r| is small and thus the second terms in the correction
-//  are unneccessary.
+//  are unnecessary.
 //
 //  Finally, sin(r) and cos(r) are approximated by polynomials of
 //  moderate lengths.
diff --git a/sysdeps/ia64/fpu/libm_sincosl.S b/sysdeps/ia64/fpu/libm_sincosl.S
index f76b54d3de..b0d027caf5 100644
--- a/sysdeps/ia64/fpu/libm_sincosl.S
+++ b/sysdeps/ia64/fpu/libm_sincosl.S
@@ -205,7 +205,7 @@
 //           = (-1)^i_0 * [cosl(r) - c*r] if i_1 = 1
 //
 //  because |r| is small and thus the second terms in the correction
-//  are unneccessary.
+//  are unnecessary.
 //
 //  Finally, sinl(r) and cosl(r) are approximated by polynomials of
 //  moderate lengths.
diff --git a/sysdeps/ia64/fpu/s_cosl.S b/sysdeps/ia64/fpu/s_cosl.S
index ed4b571fab..961b8d23ce 100644
--- a/sysdeps/ia64/fpu/s_cosl.S
+++ b/sysdeps/ia64/fpu/s_cosl.S
@@ -212,7 +212,7 @@
 //           = (-1)^i_0 * [cosl(r) - c*r] if i_1 = 1
 //
 //  because |r| is small and thus the second terms in the correction
-//  are unneccessary.
+//  are unnecessary.
 //
 //  Finally, sinl(r) and cosl(r) are approximated by polynomials of
 //  moderate lengths.
diff --git a/sysdeps/ieee754/dbl-64/k_rem_pio2.c b/sysdeps/ieee754/dbl-64/k_rem_pio2.c
index 6221a1a474..6e2ef5d07b 100644
--- a/sysdeps/ieee754/dbl-64/k_rem_pio2.c
+++ b/sysdeps/ieee754/dbl-64/k_rem_pio2.c
@@ -45,7 +45,7 @@ static char rcsid[] = "$NetBSD: k_rem_pio2.c,v 1.7 1995/05/10 20:46:25 jtc Exp $
  *			z    = (z-x[i])*2**24
  *
  *
- *	y[]	ouput result in an array of double precision numbers.
+ *	y[]	output result in an array of double precision numbers.
  *		The dimension of y[] is:
  *			24-bit  precision	1
  *			53-bit  precision	2
diff --git a/sysdeps/unix/sockatmark.c b/sysdeps/unix/sockatmark.c
index 2fe9abbf53..c36401ab90 100644
--- a/sysdeps/unix/sockatmark.c
+++ b/sysdeps/unix/sockatmark.c
@@ -18,7 +18,7 @@
 #include <sys/ioctl.h>
 #include <sys/socket.h>
 
-/* Determine wheter socket is at a out-of-band mark.  */
+/* Determine whether socket is at a out-of-band mark.  */
 int
 sockatmark (int fd)
 {
diff --git a/time/strptime_l.c b/time/strptime_l.c
index d8aed0d5f6..58b271eb37 100644
--- a/time/strptime_l.c
+++ b/time/strptime_l.c
@@ -306,7 +306,7 @@ __strptime_internal (const char *rp, const char *fmt, struct tm *tmp,
 	}
 
       /* Any character but `%' must be matched by the same character
-	 in the iput string.  */
+	 in the input string.  */
       if (*fmt != '%')
 	{
 	  match_char (*fmt++, *rp++);